/**
 * Copyright (C) 2003-2005 Funambol
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA 
 */

package sync4j.syncclient.sps;

/**
 * This class implements record definition
 * Record contain those fields:
 * <pre>
 * key     - record key
 * state   - record state ('N' new, 'U' update, 'D' deleted)
 * content - record value
 * </pre>
 * @author Fabio Maggi
 * @version $Id: Record.java,v 1.2 2005/01/19 11:17:41 fabius Exp $
 *
 **/
public final class Record {

    //---------------------------------------------------------------------------- Private data

    private String key     =  null ;
    private char   state   =  ' '  ;
    private String content =  null ;

    //---------------------------------------------------------------------------- Constructors

    public Record(String allRecord) {

        this.key      = allRecord.substring(0, allRecord.indexOf("|"))             ;
        this.state    = allRecord.substring(allRecord.indexOf("|") + 1).charAt(0)  ;
        String tmp    = allRecord.substring(allRecord.indexOf("|") + 1)            ;
        this.content  = tmp.substring(tmp.indexOf("|") + 1)                        ;

    }

    public Record(String key, char state, String content) {
        this.key      = key     ;
        this.state    = state   ;
        this.content  = content ;
    }

    public Record() {

    }

    //------------------------------------------------------------------------------ Public methods

    public String getKey() {
        return this.key;
    }

    public void setKey(String key) {
        this.key=key;
    }

    public char getState() {
        return this.state;
    }

    public void setState(char state) {
        this.state = state;
    }

    public String getContent() {
        return this.content;
    }

    public void setContent(String content) {
        this.content = content;
    }

    public String toString() {
        return this.key                    +
               "|"                         +
               String.valueOf(this.state)  +
               "|"                         +
               this.content                ;
    }

}